<?php
include_once('../global.php');

class BackupManagePage extends Page
{
  var $FullTitle = 'Zálohovací systém';
  var $ShortTitle = 'Nastavení zálohování';
  
  function Show()
  {  
	if(!$this->System->Modules['User']->CheckPermission('Network', 'Administration')) return('Nemáte oprávnění');
	
    $this->Database->select_db('backup');
    $zpet = '<p><a href="index.php">Zpět</a></p>';

    if(!array_key_exists('action', $_GET)) $_GET['action'] = '';

    $Output = '';
    switch($_GET['action'])
    {
      case 'add':
        $this->Database->insert('items', array('name' => $_POST['name'], 'parent' => $_POST['parent'], 'description' => $_POST['description']));
        $Output .= '<p>Položka byla přidána.</p>'.$zpet;
        break;
      case 'backup_now':
        $Output .= '<pre>'.exec('/a/bin/backup-user.sh').'</pre>';
        $Output .= '<p>Záloha byla vytvořena.</p>'.$zpet;
        break;
      case 'edit':
        $this->Database->update('items','id = '.$_POST['id'], array('name' => $_POST['name'], 'description' => $_POST['description']));
        $Output .= '<p>Položka byla upravena.</p>'.$zpet;
        break;
      case 'update':
        //print_r($_POST);
        while(list($key, $val) = each($_POST))
        {
          list($command, $id) = explode("_", $key);
          switch($command)
          {
            case 'edit':
              $Output .= '<strong>Úprava položky:</strong><br/>';
              $DbResult = $this->Database->query('SELECT * FROM items WHERE id='.$id);
              while ($Item = $DbResult->fetch_assoc())
              {
                $Output .= '<form action="index.php?action=edit" method="post"><input type="hidden" name="id" value="'.$id.'">';
                $Output .= 'Název/cesta<br/><input type="text" name="name" value="'.$Item['name'].'"><br/>Popis<br/><input type="text" name="description" value="'.$Item['description'].'"><br/><input type="submit" value="Odeslat"></form>';
              }
              break;
            case 'remove':
              $this->Database->query('DELETE FROM items WHERE id='.$id);
              $Output .= '<p>Položka byla smazána!</p>'.$zpet;
              break;
            case 'except':
              $Output .= '<strong>Přidání vyjímky:</strong><br/>';
              $DbResult = $this->Database->query('SELECT * FROM items WHERE id='.$id);
              while ($Item = $DbResult->fetch_array()) 
              {
                $Output .= '<form action="index.php?action=add" method="post"><input type="hidden" name="parent" value="'.$id.'">';
                $Output .= 'Název/cesta<br/><input type="text" name="name"><br/>Popis<br/><input type="text" name="description""><br/><input type="submit" value="Odeslat"></form>';
              }
              break;
          }
          $Output .= $zpet;
        }
        break;
      default:
        $Output .= '<form action="index.php?action=update" method="post">';
        $Output .= '<table width="100%"><tr><td width="50%" valign="top">';
        // Seznam segmentů a zařízení
        $Output .= 'Seznam zálohovaných složek:<br><table border="1" cellspacing="0" cellpadding="3"><tr><th>Název/cesta</th><th>Popis</th><th>Operace</th></tr>';
        $DbResult = $this->Database->query('SELECT * FROM items WHERE parent=0');
        while($Row = $DbResult->fetch_array())
        {
          $Output .= '<tr><td>'.$Row['name'].'</td><td>&nbsp;'.$Row['description'].'</td><td><input type="submit" name="edit_'.$Row['id'].'" value="Upravit"/><input type="submit" name="remove_'.$Row['id'].'" value="Vymazat"/><input type="submit" name="except_'.$Row['id'].'" value="Přidat vyjímku"/></td></tr>';
          $DbResult2 = $this->Database->query("SELECT * FROM items WHERE parent=".$Row['id']);
          while($Except = $DbResult2->fetch_array())
          {
            $Output .= '<tr><td>-&nbsp;&nbsp;'.$Except['name'].'</td><td>&nbsp;'.$Except['description'].'</td><td><input type="submit" name="edit_'.$Except['id'].'" value="Upravit vyjímku"/><input type="submit" name="remove_'.$Except['id'].'" value="Vymazat vyjímku"/></td></tr>';
          }
        }
        $Output .= '</table><br/></form>';
        $Output .= '<strong>Přidat položku</strong><br/>';
        $Output .= '<form action="index.php?action=add" method="post">Název/cesta<br/><input type="text" name="name"><br/>Popis<br/><input type="text" name="description"><br/><input type="submit" value="Odeslat"></form>';
        $Output .= '<strong>Provést zálohování</strong><br/>';
        $Output .= '<form action="index.php?action=backup_now" method="post"><input type="submit" value="Zálohuj"></form>';
        $Output .= '<strong>Popis zálohovacího systému</strong><br>Data jsou zálohována na pomocný 11 GB disk jako komprimovaný soubor. Zálohy dalších velkých souborů je nutné provádět ručně na klientské počítače správců sítě.<br/>Složky jsou kopírovány rekurzivně do hloubky (tzn. včetně podsložek). Pokud nechcete, aby složka byla procházena do hloubky, uveďte za její cestu "/*", jinak ale za názvem lomítko neuvádějte. Kromě toho je možné ke každé složce uvést seznam vyjímek. Ty jsou uváděny jako relativní cesty k souborům a složkám.<br>';
	}
	return($Output);
  }
}

$System->AddModule(new BackupManagePage());
$System->Modules['BackupManagePage']->GetOutput();

?>
